VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsRecordset"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"

'
'   clsRecordset.cls
'


'   Created in August 2002 by G.Wirth, Ulm, Germany
'   Email: g.wirth@swp.de
'
'   Enjoy. It's free and maybe well worth ;)
'
'   It would be gently to leave this few lines intact. Thx.


'   Using this VB5/VB6 DAO class it's pretty easy to read or write single values
'   to a table in a given database. (Sometimes it must not be the three tier-data
'   mining-giant-oversized-solution ;) )
'
'   Feel free to email any suggestions / errors (ups!) .


Option Explicit



' *************************************
' *        PUBLIC ENUMS               *
' *************************************
Public Enum enKeepOpen
    RS_KEEP_OPEN = 1
    RS_DONT_KEEP_OPEN = 2
End Enum

Public Enum enRaiseSuccessEvent
    RS_RAISE_SUCCESS_EVENT = 1
    RS_DONT_RAISE_SUCCESS_EVENT = 2
End Enum

Public Enum enAddKey
    RS_ADD_KEY_IF_NECCESSARY = 1                ' In Let(value) : Add a key value if it doesn't exists.
    RS_DONT_ADD_KEY = 2                         ' Pay attention to table structure ! (other needed fields...)
End Enum

Public Enum enErrorType
    RS_ET_SUCCESS_NO_ERROR
    RS_ET_DATABASE_NOT_SET
    RS_ET_TABLE_NOT_SET
    RS_ET_KEY_COLUMN_NOT_SET
    RS_ET_VALUE_COLUMN_NOT_SET
    RS_ET_ERROR_OPENING_RS
    RS_ET_KEY_NOT_FOUND
    RS_ET_WRITE_ERROR
    RS_ET_READ_ERROR
End Enum


' *******************************
' *            EVENTS           *
' *******************************
Public Event ErrorRS(ByVal ErrorType As enErrorType, ByVal sErrorDesc As String, ByVal flgFatal As Boolean)


' *************************************
' *            PRIVATES               *
' *************************************

' Set/Let/Get
Private m_DB                    As Database
Private m_sTable                As String
Private m_sSQL_WHERE            As String
Private m_sKeyColumn            As String
Private m_sValueColumn          As String
Private m_KeepOpen              As enKeepOpen
Private m_AddKey                As enAddKey
Private m_RaiseSuccessEvent     As enRaiseSuccessEvent

' Intern
Private RS                      As Recordset
'
'
'




' *************************************
' *            INIT/TERM              *
' *************************************

Private Sub Class_Initialize()

    ResetToDefaults

End Sub

Private Sub Class_Terminate()

    Set RS = Nothing
    Set m_DB = Nothing
    
End Sub



' *************************************
' *         PUBLIC FUNCTIONS          *
' *************************************

Public Function SetDefaults( _
        Optional DBused As Database, _
        Optional sTable As String = "", _
        Optional sKeyColumn As String = "", _
        Optional sValColumn As String = "", _
        Optional sSQL_WHERE As String = "", _
        Optional KeepOpen As enKeepOpen, _
        Optional AddKey As enAddKey, _
        Optional RaiseSuccessEvent As enRaiseSuccessEvent)

    ' The dirty 'All-In-One' preset ;)
    ' So we have three ways to set what we need. Make your choice!
    

    ' New defaults ? > Mostly needs new OpenRS, so we do ...
    Set RS = Nothing

    If DBused Is Nothing = False Then
        Me.DatabaseUsed = DBused
    End If

    If sTable <> "" Then
        Me.Table = sTable
    End If

    If sKeyColumn <> "" Then
        Me.KeyColumn = sKeyColumn
    End If

    If sValColumn <> "" Then
        Me.ValueColumn = sValColumn
    End If

    If sSQL_WHERE <> "" Then
        Me.SQL_WHERE = sSQL_WHERE
    End If
         
    If IsMissing(KeepOpen) = False Then
        Me.KeepOpen = KeepOpen
    End If
    
    If IsMissing(AddKey) = False Then
        Me.AddKey = AddKey
    End If
    
    If IsMissing(RaiseSuccessEvent) = False Then
        Me.RaiseSuccessEvent = RaiseSuccessEvent
    End If
    
End Function


Public Sub CloseConnection()
    
    ResetToDefaults
    
End Sub



' *************************************
' *         PRIVATE FUNCTIONS         *
' *************************************

Private Sub ResetToDefaults()

    Set RS = Nothing
    
    Set m_DB = Nothing
    m_sTable = ""
    m_sSQL_WHERE = ""
    m_sKeyColumn = ""
    m_sValueColumn = ""
    m_KeepOpen = RS_DONT_KEEP_OPEN
    m_AddKey = RS_DONT_ADD_KEY
    m_RaiseSuccessEvent = RS_DONT_RAISE_SUCCESS_EVENT

End Sub

Private Function OpenRS() As Boolean

    On Error GoTo ERR_OpenRS

    OpenRS = False

    If m_DB Is Nothing Then
        RaiseEvent ErrorRS(RS_ET_DATABASE_NOT_SET, "Database object not set!", True)
    
        Exit Function
    End If

    If m_sTable = "" Then
        RaiseEvent ErrorRS(RS_ET_TABLE_NOT_SET, "Table not set!", True)
    
        Exit Function
    End If

    If m_sKeyColumn = "" Then
        RaiseEvent ErrorRS(RS_ET_KEY_COLUMN_NOT_SET, "Key column not set!", True)
    
        Exit Function
    End If
    
    If m_sValueColumn = "" Then
        RaiseEvent ErrorRS(RS_ET_VALUE_COLUMN_NOT_SET, "Value column not set!", True)
    
        Exit Function
    End If
    

    Set RS = m_DB.OpenRecordset("SELECT " + m_sKeyColumn + ", " + m_sValueColumn + _
                                " FROM " + m_sTable + " " + _
                                m_sSQL_WHERE, _
                                dbOpenDynaset)
    
    If RS Is Nothing Then
        RaiseEvent ErrorRS(RS_ET_ERROR_OPENING_RS, "No recordset object after opening!", True)
        
        Exit Function
    End If
    
    
    OpenRS = True
        
    On Error GoTo 0
    
    Exit Function


ERR_OpenRS:

    RaiseEvent ErrorRS(RS_ET_ERROR_OPENING_RS, "Error opening recordset:  '" + Err.Description, True)

End Function



' *************************************
' *           PROPERTIES              *
' *************************************


Public Property Let Value( _
        sKey As String, _
        Optional KeepOpen As enKeepOpen, _
        Optional AddKey As enAddKey, _
        Optional DBused As Database, _
        Optional sTable As String = "", _
        Optional sKeyColumn As String = "", _
        Optional sValColumn As String = "", _
        Optional sSQL_WHERE As String = "", _
        ByVal vData As Variant)


    Dim flgNeedReOpen As Boolean

    On Error GoTo ERR_Value

    flgNeedReOpen = False


    If DBused Is Nothing = False Then
        flgNeedReOpen = IIf(DBused Is Me.DatabaseUsed, True, flgNeedReOpen)
        Me.DatabaseUsed = DBused
    End If

    If sTable <> "" Then
        flgNeedReOpen = IIf(sTable <> m_sTable, True, flgNeedReOpen)
        Me.Table = sTable
    End If

    If sKeyColumn <> "" Then
        flgNeedReOpen = IIf(sKeyColumn <> m_sKeyColumn, True, flgNeedReOpen)
        Me.KeyColumn = sKeyColumn
    End If

    If sValColumn <> "" Then
        flgNeedReOpen = IIf(sValColumn <> m_sValueColumn, True, flgNeedReOpen)
        Me.ValueColumn = sValColumn
    End If

    If sSQL_WHERE <> "" Then
        flgNeedReOpen = IIf(sSQL_WHERE <> m_sSQL_WHERE, True, flgNeedReOpen)
        Me.SQL_WHERE = sSQL_WHERE
    End If

    If RS Is Nothing Or flgNeedReOpen = True Then
        OpenRS
    End If
    
    If IsMissing(AddKey) = False Then
        Me.AddKey = AddKey
    End If
    
    If IsMissing(KeepOpen) = False Then
        Me.KeepOpen = KeepOpen
    End If

    With RS
        
        .FindFirst m_sKeyColumn + " = '" + sKey + "'"
        
        If .NoMatch = True Then
            
            If Me.AddKey = RS_ADD_KEY_IF_NECCESSARY Then
                .AddNew
                    .Fields(m_sKeyColumn) = sKey
                    .Fields(m_sValueColumn) = vData
                .Update
                If Me.RaiseSuccessEvent = RS_RAISE_SUCCESS_EVENT Then
                    RaiseEvent ErrorRS(RS_ET_SUCCESS_NO_ERROR, "Successfully key added/value written.", False)
                End If
            Else
                RaiseEvent ErrorRS(RS_ET_KEY_NOT_FOUND, _
                        "Key '" + sKey + "' not found in '" + m_sKeyColumn + "'. Value not set!", _
                        False)
                If Me.KeepOpen = RS_DONT_KEEP_OPEN Then
                    Set RS = Nothing
                End If
                
                Exit Property
            End If
            
        Else
        
            .Edit
                .Fields(m_sValueColumn) = vData
            .Update
            
            If Me.RaiseSuccessEvent = RS_RAISE_SUCCESS_EVENT Then
                RaiseEvent ErrorRS(RS_ET_SUCCESS_NO_ERROR, "Successfully value written.", False)
            End If
            
        End If
    End With
        

    If Me.KeepOpen = RS_DONT_KEEP_OPEN Then
        Set RS = Nothing
    End If
    
    On Error GoTo 0
    
    Exit Property


ERR_Value:
    
    RaiseEvent ErrorRS(RS_ET_WRITE_ERROR, "Error writing a value: " + Err.Description, False)

End Property

Public Property Get Value( _
        sKey As String, _
        Optional KeepOpen As enKeepOpen, _
        Optional AddKey As enAddKey, _
        Optional DBused As Database, _
        Optional sTable As String = "", _
        Optional sKeyColumn As String = "", _
        Optional sValColumn As String = "", _
        Optional sSQL_WHERE As String = "") As Variant

    ' AddKey doesn't make any real sence in getting a value,
    ' but is needed to match var list in get/let ... :(
    
    Dim flgNeedReOpen As Boolean

    On Error GoTo ERR_Value


    flgNeedReOpen = False

    If DBused Is Nothing = False Then
        flgNeedReOpen = IIf(DBused Is Me.DatabaseUsed, True, flgNeedReOpen)
        Me.DatabaseUsed = DBused
    End If

    If sTable <> "" Then
        flgNeedReOpen = IIf(sTable <> m_sTable, True, flgNeedReOpen)
        Me.Table = sTable
    End If

    If sKeyColumn <> "" Then
        flgNeedReOpen = IIf(sKeyColumn <> m_sKeyColumn, True, flgNeedReOpen)
        Me.KeyColumn = sKeyColumn
    End If

    If sValColumn <> "" Then
        flgNeedReOpen = IIf(sValColumn <> m_sValueColumn, True, flgNeedReOpen)
        Me.ValueColumn = sValColumn
    End If

    If sSQL_WHERE <> "" Then
        flgNeedReOpen = IIf(sSQL_WHERE <> m_sSQL_WHERE, True, flgNeedReOpen)
        Me.SQL_WHERE = sSQL_WHERE
    End If
    
    If IsMissing(AddKey) = False Then
        Me.AddKey = AddKey
    End If
    
    If IsMissing(KeepOpen) = False Then
        Me.KeepOpen = KeepOpen
    End If

    If RS Is Nothing Or flgNeedReOpen = True Then
        If OpenRS() = False Then
            
            Exit Property
        End If
    End If

    With RS
        .FindFirst m_sKeyColumn + " = '" + sKey + "'"
        If .NoMatch = False Then
            Value = .Fields(m_sValueColumn)
        Else
            RaiseEvent ErrorRS(RS_ET_KEY_NOT_FOUND, "Key '" + sKey + "' not found! Can't get value.", False)
            
            Exit Property
        End If
    End With

    If Me.RaiseSuccessEvent = RS_RAISE_SUCCESS_EVENT Then
        RaiseEvent ErrorRS(RS_ET_SUCCESS_NO_ERROR, "Successfully got value!", False)
    End If

    If Me.KeepOpen = RS_DONT_KEEP_OPEN Then
        Set RS = Nothing
    End If


   On Error GoTo 0
   
   Exit Property


ERR_Value:

    RaiseEvent ErrorRS(RS_ET_READ_ERROR, _
            "Error reading a value! Key = '" + sKey + "' - Err: " + Err.Description, False)

End Property


Property Get KeepOpen() As enKeepOpen
    
    KeepOpen = m_KeepOpen

End Property

Property Let KeepOpen(ByVal newValue As enKeepOpen)
    
    m_KeepOpen = IIf(newValue > 0, newValue, m_KeepOpen)
    
End Property


Property Get RaiseSuccessEvent() As enRaiseSuccessEvent

    RaiseSuccessEvent = m_RaiseSuccessEvent

End Property

Property Let RaiseSuccessEvent(ByVal newValue As enRaiseSuccessEvent)

    m_RaiseSuccessEvent = IIf(newValue > 0, newValue, m_RaiseSuccessEvent)

End Property


Property Get ValueColumn() As String
    
    ValueColumn = m_sValueColumn

End Property

Property Let ValueColumn(ByVal newValue As String)
    
    m_sValueColumn = newValue

End Property


Property Get KeyColumn() As String
    
    KeyColumn = m_sKeyColumn

End Property

Property Let KeyColumn(ByVal newValue As String)
    
    m_sKeyColumn = newValue

End Property


Property Get DatabaseUsed() As Database
Attribute DatabaseUsed.VB_Description = "Wo liegt die Datenbank-Datei ?"
    
    Set DatabaseUsed = m_DB

End Property

Property Let DatabaseUsed(ByVal newValue As Database)
    
    Set m_DB = newValue
            
End Property


Property Get Table() As String
Attribute Table.VB_Description = "Name der Tabelle, die bearbeitet wird"
    
    Table = m_sTable

End Property

Property Let Table(ByVal newValue As String)
    
    m_sTable = newValue

End Property


Public Property Let SQL_WHERE(ByVal vData As String)
    
    m_sSQL_WHERE = vData
    
End Property

Public Property Get SQL_WHERE() As String
    
    SQL_WHERE = m_sSQL_WHERE

End Property


Property Get AddKey() As enAddKey
    
    AddKey = m_AddKey

End Property

Property Let AddKey(ByVal newValue As enAddKey)
    
    m_AddKey = IIf(newValue > 0, newValue, m_AddKey)

End Property


' #*#




